// Reports.vue

<template>
    <div class="logo" style="height:150px"></div>
    <h1>Reports</h1>
    <router-link to="/">Back</router-link>
    <div>
      <p></p>
      <div>
        <input id="startDate" placeholder="mm-dd-yyyy"> - 
        <input id="endDate" placeholder="mm-dd-yyyy">
        <button class="search-report-btn" @click.prevent="confirmDates" type="button">search</button>
      </div>
      <p></p>
      <table style="margin-left: auto; margin-right: auto">
        <thead>
          <tr>
            <th style="text-align: left; width: 10rem;">
              Date
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="report in reports" :key="report.date">
            <td style="text-align: left" v-if="report">
              <router-link :to="{name: 'ViewReport', params: { date: report.date}}">{{report.date}}</router-link>
            </td>
          </tr>
        </tbody>
      </table>
      <div v-show="status === 'errored'">Could not load reports.</div>
      <div v-show="status === 'loading'">Loading reports. Please wait...</div>
      <div v-show="status === 'loaded' && reports.length === 0">No reports.</div>
    </div>
</template>

<script>
import axios from 'axios';
import { BACKEND_BASE_URL } from '../env.js';

export default {
  name: "Reports",
  data(){
    return {
      reportList: [],
      reports: [],
      status: 'loading', // loaded, errored
      startDate: null,
      endDate: null
    }
  }, 
  created: function() {
    const today = new Date();
    this.endDate = today;
    let thirty = new Date(new Date().setDate(today.getDate()-30));
    this.startDate = thirty;
    console.log(this.endDate);
    console.log(this.startDate);

    this.getReports()
     .then(() => {
        this.refreshReports();
     })
  },
  methods: {
    async getReports() {
      try {
          let url = BACKEND_BASE_URL + "/reports";
          let response = await axios.get(url);
          console.log(response);
          this.reportList = response.data.slice().reverse();
      } catch (error) {
          console.error(error);
          this.status = 'errored';
      }
    },
    refreshReports() {
      this.reports = [];
      for (let report of this.reportList) {
        let date = new Date(report.date);
        console.log(date);
        if (date >= this.startDate && date <= this.endDate) {
          this.reports.push(report);
        }
      }
      this.status = 'loaded';
    },
    confirmDates() {
      let s = document.getElementById("startDate").value;
      let e = document.getElementById("endDate").value;
      this.startDate = new Date(s);
      this.endDate = new Date(e);

      this.refreshReports();
    }
  }
}
</script>

<style>
  .logo {
    background-image: url("../public/wne-logo-2.png");
    background-repeat: no-repeat;
    background-size: 40%;
    background-position: center
  }

  .search-report-btn {
    font-size: .8rem;
    font-weight: bold;
    padding-top: .1rem;
    padding-bottom: .1rem;
  }

  .search-report-btn:hover {
    color: blue
  }

  @media screen and (min-width: 1800px) {
  .logo {
    background-size: 30%;
  }
}
</style>